************************************************************************************************************
*Created by Nicola Branson, SALDRU, University of Cape Town. Email: nicola.branson@uct.ac.za

*WEIGHTS
*format.wgtsdata.do
*uses OHS, LFS & GHS data
*renames unique hh identifier to original name and save individual files
*saves  data in $general\output 
************************************************************************************************************
clear
cap set mem 600m
set more off
*filepaths

cd e:\
global ghsfiles "\SALDRU_210409\General Household Survey"
global ohsfiles "\SALDRU_210409\October Household Survey 1993-99"
global lfsfiles "\SALDRU_210409\labour force survey 2000-"
global general="\SALDRU_210409\WEIGHTS"
global tempfiles="\SALDRU_210409\WEIGHTS\temp.dta" 
************************************************************************************************************
*from each data set will need
*hhweight uqnr personnr province age sex race
***OHS 1993--incomplete!
/*
use "$ohsfiles\Diego\1993\STATA\persons.dta", clear
destring *, replace
*2 cases where  uniqnum is missing, other information is not missing (all from the transvaal)
rename  UNIQ_NUM uniqnum
rename  PERSON person
drop if  uniqnum==.
isid  uniqnum person

drop weight /* household weight has the same name in the household */
sort uniqnum 
***this file has no household identifier!
merge uniqnum using "$ohsfiles\Diego\1993\STATA\house.dta"
*no unique id in the household file
isid  HHID PPERSNO
assert _m==3
numlabel, add

rename HHID uqnr
rename PPERSNO personnr
rename  PAGE age
*no missing category
rename PGENDER sex
replace sex=. if sex>2
rename PRACE1 race
replace race=. if race>4
rename PROV province
rename  HHWGT hhweight

keep uqnr personnr age sex race province hhweight
save "$tempfiles\ohs1993.dta", replace

*/


/*this is the reweighted data

use "$ohsfiles\OHS 1995\Data\Reweighted Data\Stata\OHS 1995 Person_1996 Weights.dta", clear
isid  hhid  PERSNO
drop NEWWGT /* household weight also called weight*/
sort hhid 
merge hhid using "$ohsfiles\OHS 1995\Data\Reweighted Data\Stata\OHS 1995 House_1996 Weights.dta"
isid  hhid  PERSNO
assert _m==3
numlabel, add
destring, replace

rename hhid uqnr
rename PERSNO personnr
*no missing category
rename AGE age 
rename GENDER sex
replace sex=. if sex>2
rename pop_grp race
replace race=. if race>4
rename  NEWWGT1 hhweight

keep uqnr personnr age sex race province hhweight
save "$tempfiles\ohs1995.dta", replace
*/

***OHS 1996-incomplete/problematic
/*
use "$ohsfiles\Diego\1996\STATA\Person", clear
isid  MDNUMBER EANUMBER VPNUMBER RESPONNO
sort MDNUMBER EANUMBER VPNUMBER 
preserve
use "$ohsfiles\Diego\1996\STATA\House.dta", clear
sort MDNUMBER EANUMBER VPNUMBER 
save "$ohsfiles\Diego\1996\STATA\House.dta", replace
restore
***MDNUMBER EANUMBER VPNUMBER is not unique within households!***
merge MDNUMBER EANUMBER VPNUMBER using "$ohsfiles\Diego\1996\STATA\House.dta"
*individuals without households!
drop if _m==1
assert _m==3
isid MDNUMBER EANUMBER VPNUMBER
numlabel, add

rename UQNR uqnr
rename PERSNO personnr
rename  AGE age
*no missing category
rename GENDER sex
replace sex=. if sex>2
rename POPGRP race
replace race=. if race>4
rename PROV province
rename  WEIGHT hhweight

keep uqnr personnr age sex race province hhweight
save "$tempfiles\ohs1996.dta", replace
*/

set more off
****OHS****
foreach x in 1997 1995{ 
use "$general\output\ohs`x'_entwgt.dta", clear
rename uqnr HHID
save "$general\output\ohs`x'.cewgt.dta", replace
}

foreach x in 1999 1998 1994{ 
use "$general\output\ohs`x'_entwgt.dta", clear
rename uqnr UQNR
save "$general\output\ohs`x'.cewgt.dta", replace
}


****LFS****
foreach x in 2006_1 2004_1 2003_2 2003_1 2002_2 2002_1 2001_2 2001_1 2000_2 2000_1{ 
use "$general\output\lfs`x'_entwgt.dta", clear
rename  uqnr UqNr 
save "$general\output\lfs`x'.cewgt.dta", replace
}


foreach x in 2007_1 2007_2 2006_2 2005_2 2005_1 2004_2{ 
use "$general\output\lfs`x'_entwgt.dta", clear
*unnessary
save "$general\output\lfs`x'.cewgt.dta", replace
}


****GHS****
foreach x in 2002 2003 2004 {
use "$general\output\ghs`x'_entwgt.dta", clear
rename uqnr UqNr
save "$general\output\ghs`x'.cewgt.dta", replace
}

**2004-2007
foreach x in 2004 2005 2006 2007{
use "$general\output\ghs`x'_entwgt.dta", clear
*unnessary
save "$general\output\ghs`x'.cewgt.dta", replace
}

**end of format.wgtsdata.do file
